function [v,dist,q2n] = FindGeodesicVector(q1,q2,X2,lam)

n = size(q1,1);
if (norm(q1-q2) < 0.001)
    v = zeros(size(q1));
    dist = 0;
    q2n=q2;
else
    A = q1*q2';
    [U,S,V] = svd(A);
    if det(A)> 0
        Ot = U*V';
    else
        if n == 2
            Ot = U*([V(:,1) -V(:,2)])';
        else
            Ot = U*([V(:,1) V(:,2) -V(:,3)])';
        end
    end
    X2 = Ot*X2;
    q2 = Ot*q2;
    
    [gam] = DynamicProgrammingQ_Adam(q2,q1,lam,0);
    gam = (gam-gam(1))/(gam(end)-gam(1));
    X2n = Group_Action_by_Gamma_Coord(X2,gam);
    q2n = curve_to_q(X2n);

    dist = acos(InnerProd_Q(q1,q2n));
    
    v = (dist/sin(dist))*(q2n - cos(dist)*q1);
end