clear; close all;

load('spiraldata100.mat')

%% Shape geodesic examples between two randomly selected objects
rng(10010101)

p1=X1(:,:,ceil(rand*70));
p2=X1(:,:,ceil(rand*70));

d = my3Dgeod(p1,p2);

%% Mean, Covariance and Sampling Example 1
Data=X1(:,:,1:50);

% Display some of the data
stp=.2;
figure(20),clf,hold on
for j=1:2:20
    X = ReSampleCurve(Data(:,:,j),100);
    q = curve_to_q(X);
    Data(:,:,j)=q_to_curve(q);
    plot(Data(1,:,j)+stp*(j-1),Data(2,:,j),'LineWidth',2)
end
axis equal off

%Compute the mean
[mu,q,X,muX] = FindMean3Dcurve(Data);

%Compute the covariance and PCA
U=OpenCurveCovarianceAndSample(mu,q,X,5);